;权力均衡还是附势

breed [ nations nation ]



undirected-link-breed [ alliances alliance ]
undirected-link-breed [ wars war ]
directed-link-breed [ alliance-requests alliance-request ]

globals [
  Country-ratio
  sum-power
  great-power
  weak-power
  nation-num
]

links-own [link-length-nation]

nations-own [
  power
  ally-power
  war-effort
  bellicosity
  allies?
  duration
  active?
  If-State
  Opportunist
  betrayer

]

to setup
   ca
  import-drawing  "3.jpg"
  import-pcolors  "3.jpg"
  setup-agents
  reset-ticks
end


to setup-agents
  set-default-shape nations "circle"

  let nation-area patches with [  pcolor > 10 and pcolor < 80 and pcolor != 69.9
    and not any? neighbors with [pcolor < 10 or pcolor > 80 or pcolor = 69.9 or pcolor = 49.9 ] ]

 ;数量还原历史
  ask n-of amount-nations nation-area
  [
      sprout-nations 1[
      set color ([pcolor] of self  - 3 )
      set power  random-float 100
      set size  ( 1 + 2 * ( power / 100 ) )
      set bellicosity  ( size / 10 )
      set active? true
      set betrayer 0
      set label who
      set label-color black

    ]]
  ask links [set link-length-nation 0]
  set great-power count nations with [power >= 90]

  if great-power > 0 and great-power <= 10
  [
    ask n-of (10 - great-power) nations with [power < 90]
    [set power 90]
  ]
 if great-power > 10
  [
    ask n-of ( great-power - 10 ) nations with [power >= 90]
    [set power  random 90]
]
 ;设置国家属性
 ask nations [
    ifelse power >= 90 [ set If-State 1] [set If-State 0]
     ]
  ask n-of Opportunist-num nations [set Opportunist 1]
  set sum-power  sum [ power ] of nations
end



to  go
  ask wars [ die ]
  ask nations with [active? = true] [
    set allies? count alliance-neighbors

    if random-float 1 >= 0.65 [ replenish-power]

    if random-float 1  <= Alliances-Ratio [
    offer-alliance
    accept-alliance]
    if random-float 1 >= 0.613 [ declare-war]
    if Opportunist = 1 [ opt-out ]
    wage-war
    perish
    set size ( 1 + 2 * ( power / 94 ) )
  ]

  tick
  ask nations with [active? = true ] [
  set duration ticks]
  ask alliance-requests [ die ]

  if count nations with [active? = true] <= 32 [
  ask wars [ die ]
  import-drawing  "4.jpg"
  import-pcolors  "4.jpg"

  stop]
  ;show word "nations: " (count nations with [ active?  = true] - 1)
end

to replenish-power
  set power ( power + 25 - (ticks / 106)   )

  if power >= Initial-Power  [
    set power Initial-Power
  ]
end




;基础三大机制

;结盟
to offer-alliance
    if allies? = 0 [
    if any? other nations with [ allies? = 0
                                 and active? = true ] [
    ask one-of other nations with [ allies? = 0
                                    and active? = true] [

          create-alliance-request-from myself] ]
  ask alliance-requests [ set color white ]
  ]


  if allies? > 0 [
    set bellicosity bellicosity -  0.1 * allies? ;(0.04 + bellicosity-n / 10)
    if bellicosity <= 0 [
      set bellicosity 0
    ]
  ]
end


to accept-alliance
  if any? in-alliance-request-neighbors with [ power >= [power] of myself and active? = true] [
    ;ask my-out-alliances [ die ]
    if any? alliance-request-neighbors with [ active? = true]   [
    create-alliance-with one-of alliance-request-neighbors

    ]
  ask alliances [
    set color white
    set link-length-nation link-length
  ]
  ]
end


;宣战
to declare-war

  let nations-target other nations with [ not alliance-neighbor? myself
                               and  power <= [ power ] of myself
                               and distance myself <= (War-Distance + ticks / 10)
                               and active? = true]
    if any? nations-target [
      let nation-target one-of nations-target
      ifelse [betrayer] of nation-target >= 1
      [ if random-float 2.0 < ( bellicosity + Betrayal-punishment ) [
            ask nation-target
              [ create-war-with myself]
            ask wars [ set color black]
              ]]
        [if random-float 2.0 <  bellicosity  [
           ask nation-target
             [create-war-with myself]
           ask wars [ set color black]
           ]]
    ]

end


;背盟
to opt-out
  if any? alliance-neighbors with [ any? war-neighbors and active? = true ] [
    if any? alliance-neighbors with [ power < 0.8 * [power] of myself and active? = true ] [
    ask my-alliances [ die ]
    set betrayer betrayer + 1
  ]
  ]
end


to wage-war
  set ally-power sum [ power ] of alliance-neighbors
  set war-effort power + ally-power
  ask war-neighbors [
    ifelse ( [ war-effort ] of self ) * random-float 1.0 < ( [ war-effort ] of myself )
    [ ask self [set power power - random-float Losers-Loss ;+ 3.1
                set bellicosity bellicosity + (bellicosity-n / 5)  ]
      ask myself [set power power - Winers-loss - 2  ;+ random-float Losers-Loss
                  set bellicosity bellicosity + bellicosity-n]
      if bellicosity > 2 [ set bellicosity 2 ]
    ]

    [ ask myself [set power power - random-float Losers-Loss
                set bellicosity bellicosity + (bellicosity-n / 5)  ]
      ask self [set power power - Winers-loss ; + random-float Losers-Loss
                  set bellicosity bellicosity + bellicosity-n]
      if bellicosity > 2 [ set bellicosity 2 ]
    ]
  ]
end

to perish
  if power <= 0 [
     set active? false
     set duration ticks
     ask my-alliances [ die ]
     set hidden? true
  ]
end

to-report Strong-states
  report count nations with [power >= 90 and active? = true]
end


to-report Weak-States
   report count nations with [power < 90 and active? = true]
end

to-report matrix
  if ticks <= 295 or count nations = 32 [
    let m1 (list ([who] of nations) ([if-state] of nations) ([duration] of nations) ( [Opportunist] of nations)  )
    report m1 ]
end

to-report Strong
  let a sum [duration] of nations with [ if-state = 1 ]
  let b count nations with [ if-state = 1]
report  precision (a / ( b + 0.01 )  ) 3
end

to-report Weak
   let a sum [duration] of nations with [ if-state = 0 ]
  let b count nations with [ if-state = 0]
report  precision (a / ( b + 0.01 )  ) 3
end

to-report opportunists
  let a sum [duration] of nations with [ opportunist = 1 ]
  let b count nations with [ opportunist = 1]
  report  precision (a / ( b + 0.01 )  ) 3
end

to-report loyalist
  let a sum [duration] of nations with [ opportunist = 0 ]
  let b count nations with [ opportunist = 0]
  report  precision (a / ( b + 0.01 )  ) 3
end



to-report betrayers
  let a count nations with [active? = true]
  let b count nations with [betrayer >= 1 and active? = true]
  report word precision ( (b / (a + 0.001)) * 100 ) 3"%"
end

to-report loyalists
  let a count nations with [active? = true]
  let b count nations with [betrayer = 0 and active? = true]
  report word precision ( (b / (a + 0.001)) * 100 ) 3"%"
end

to-report bellicosity-all
  report  [bellicosity ] of nations with [active? = true]

end

to-report betrayers-num
  report  count nations with [betrayer >= 1 and active? = true]

end


to-report alliance-length
  report [ link-length-nation ] of links
end






;宣战的选择可以继续细化，比如大国选择远交近攻，或者远攻近交。小国如何选择，远交近攻，或者怎么
;联盟的选择也可以继续细化，比如说采取友好发展战略，不进攻只结盟
;场景也可以设置现代化的场景，比如说近代国家格局，这样可以引入gis。或者欧洲国家格局。
;背叛有很多设置机制，比如说同时背叛同时忠诚，大国背叛，小国忠诚。数量不同情况下，有忠诚有背叛，看每个国家的存活可能。
;背叛根据人群数量半途转换，看存活可能性。
;战国、五代十国、外国、欧洲地区、亚洲地区。
@#$#@#$#@
GRAPHICS-WINDOW
203
12
1084
721
-1
-1
8.644
1
10
1
1
1
0
0
0
1
-50
50
-40
40
0
0
1
ticks
30.0

BUTTON
21
23
87
56
Setup
Setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
120
23
187
56
Go
go\n
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
17
644
100
678
go
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
1089
13
1489
257
Overall power
Time
Power
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"power" 1.0 0 -16449023 true "" "ask nations with [active? = true] [ \ncreate-temporary-plot-pen ( word who )\n  set-plot-pen-color pcolor\n  plot power]"
"pen-1" 1.0 0 -7500403 true "auto-plot-off\nplotxy 0 0\nplotxy 100000000000000   0\nauto-plot-on" "auto-plot-off\nplotxy 0 0\nplotxy 100000000000000   0\nauto-plot-on"

PLOT
1090
265
1490
421
bellicosity
Time
Bellicosity
0.0
10.0
0.0
1.1
true
false
"" ""
PENS
"bellicosity" 1.0 0 -13345367 true "" "ask nations [ \ncreate-temporary-plot-pen ( word who )\n  set-plot-pen-color green\n  plot bellicosity]"

PLOT
1090
428
1493
567
War situation
Time
Diplomatic relationship
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"Alliances" 1.0 0 -2674135 true "" "plot count alliances"
"Wars" 1.0 0 -13345367 true "" "plot count wars"

PLOT
1089
580
1493
719
Amount of nations
Time
Nations
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 1 -5825686 true "" "plot count nations with [active? = true]"

SLIDER
19
174
188
207
Amount-Nations
Amount-Nations
0
150
148.0
1
1
NIL
HORIZONTAL

SLIDER
18
220
191
253
Initial-Power
Initial-Power
0
100
100.0
1
1
NIL
HORIZONTAL

MONITOR
20
67
191
112
Strong-States
Strong-States
17
1
11

MONITOR
20
123
190
168
NIL
Weak-States
17
1
11

SLIDER
18
264
190
297
Bellicosity-N
Bellicosity-N
0
1
0.2
0.01
1
NIL
HORIZONTAL

SLIDER
17
366
191
399
Alliances-Ratio
Alliances-Ratio
0
1
0.35
0.01
1
NIL
HORIZONTAL

SLIDER
18
458
191
491
War-Distance
War-Distance
0
100
100.0
1
1
NIL
HORIZONTAL

SLIDER
16
501
192
534
Losers-Loss
Losers-Loss
0
50
9.0
1
1
NIL
HORIZONTAL

SLIDER
16
543
193
576
Winers-loss
Winers-loss
0
30
3.0
1
1
NIL
HORIZONTAL

SLIDER
18
316
190
349
Opportunist-num
Opportunist-num
0
148
148.0
1
1
NIL
HORIZONTAL

MONITOR
16
589
99
634
Strong-Ratio
Strong
17
1
11

MONITOR
105
589
194
634
Weak-Ratio
Weak
17
1
11

SLIDER
16
415
194
448
Betrayal-punishment
Betrayal-punishment
-1
1
0.0
0.01
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

crown
false
0
Rectangle -7500403 true true 45 165 255 240
Polygon -7500403 true true 45 165 30 60 90 165 90 60 132 166 150 60 169 166 210 60 210 165 270 60 255 165
Circle -16777216 true false 222 192 22
Circle -16777216 true false 56 192 22
Circle -16777216 true false 99 192 22
Circle -16777216 true false 180 192 22
Circle -16777216 true false 139 192 22

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="win" repetitions="150" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>ticks</metric>
    <metric>strong-states</metric>
    <metric>weak-states</metric>
    <metric>strong</metric>
    <metric>weak</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Winers-loss" first="1" step="1" last="2"/>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Bellicosity-N">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Opportunist-num">
      <value value="148"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Losers-Loss" first="9" step="1" last="15"/>
  </experiment>
  <experiment name="bellicosity0.8" repetitions="200" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="1000"/>
    <metric>ticks</metric>
    <metric>strong</metric>
    <metric>weak</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Winers-loss">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Bellicosity-N" first="0.2" step="0.1" last="1"/>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Opportunist-num">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Losers-Loss">
      <value value="9"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Opportunist55-100" repetitions="500" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>ticks</metric>
    <metric>strong</metric>
    <metric>weak</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Winers-loss">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Bellicosity-N">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Opportunist-num" first="55" step="5" last="100"/>
    <enumeratedValueSet variable="Losers-Loss">
      <value value="9"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Opportunist105-145" repetitions="500" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>ticks</metric>
    <metric>strong</metric>
    <metric>weak</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Winers-loss">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Bellicosity-N">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Opportunist-num" first="105" step="5" last="145"/>
    <enumeratedValueSet variable="Losers-Loss">
      <value value="9"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Opportunist0-50" repetitions="400" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>ticks</metric>
    <metric>opportunists</metric>
    <metric>loyalist</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Winers-loss">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Bellicosity-N">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <steppedValueSet variable="Opportunist-num" first="0" step="5" last="50"/>
    <enumeratedValueSet variable="Losers-Loss">
      <value value="9"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>ticks</metric>
    <metric>count links with [color = white]</metric>
    <metric>count nations with [ active?  = true]</metric>
    <enumeratedValueSet variable="Betrayal-punishment">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Winers-loss">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Amount-Nations">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Initial-Power">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="War-Distance">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Bellicosity-N">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Alliances-Ratio">
      <value value="0.35"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Opportunist-num">
      <value value="148"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Losers-Loss">
      <value value="9"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
